Build Agent Cookbook
====================

About
-----
This cookbook builds a Mac OS X TeamCity build agent with Dropbox, TextMate2, Java, Appium and Caucho's Resin installed. At the time of this writing it does require you to install either Xcode or the Xcode command line tools.

Quick Installation
-----
From your freshly formatted Mac:

First install Xcode command line tools. Keep in mind you'll need Xcode itself to build OS X and iOS projects, 
the command line tools will not suffice. I have not found a way to do this programmatically yet, so I've just 
been installing via the App Store.
	
	xcode-select --install

Then run this command (substitute the URL for your TeamCity server):

	curl -fsSL https://raw.githubusercontent.com/foreflight/foreflight_build_agent/master/setup.sh | sudo BUILD_SERVER="http://build.example.com" sh
	
Advanced Installation
------
If you want to get more advanced, use an encrypted data bag named "apple_dev_portal" and create an item named similar to below. 
This will log in to Apple's dev portal for each item, automatically download latest provisioning profiles each time chef is run. Using the `certificate_manage`
recipe allows you to save the private key in the data bag as well.

    {
      "id": "foreflightmobile",
      "password": "password",
      "username": "dev_portal_account@example.com",
      "certificates": [
        "com.foreflight.ForeFlightMobile",
        "ForeFlight LLC"
      ],
      key: "<snip>"
    }

Test Kitchen
------
Getting Test Kitchen to run Mac OS X is another story entirely, so for now, here is a screenshot of the tests passing.
![screenshot of tests passing](https://dl.dropboxusercontent.com/s/cq4ix65m1whtuwv/2015-02-23%20at%208-1.26%20PM.png)
	
License
-------
Copyright:: 2015, ForeFlight LLC, Inc

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.