user = Etc.getlogin
user_home = Dir.home(user)
user_home_launch_agents = "#{user_home}/Library/LaunchAgents"

nodejs_npm 'appium' do
  version node[:appium][:version]
  user user
end

execute 'Authorize Appium - via sudo per docs' do
  command 'sudo authorize_ios'
  user user
end

directory user_home_launch_agents do
  owner user
  recursive true
end

link "/usr/bin/node" do
  to "/usr/local/bin/node"
end

#The service resource in Chef doesn't support loading a launchd service as a specific user, which unfortunately is the
#only way Appium can run Xcode iOS Simulator.
execute 'load appium' do
  command 'launchctl load ~/Library/LaunchAgents/io.appium.server.plist'
  user user
  action :nothing #only fire when a change is made to the template.
end

template 'Setup Appium launchd' do
  source 'appium_launchd.plist.erb'
  path "#{user_home_launch_agents}/io.appium.server.plist"
  variables(
      :user => user,
      :user_home => user_home
  )
  notifies :run, 'execute[load appium]', :delayed
end

system_properties = node.default['teamcity']['agents']['default']['system_properties']
system_properties['appium_version'] = node['appium']['version']