# Do not move this or the machine will fall asleep while building. :)
include_recipe 'foreflight_build_agent::disable_screensaver'

include_recipe 'homebrew'
include_recipe 'homebrew::cask'
include_recipe 'build-essential'
include_recipe 'ssh-keys'
include_recipe 'sprout-osx-settings::screen_sharing'
include_recipe 'sprout-osx-settings::terminal_preferences'
include_recipe 'sprout-osx-settings::inputrc'
include_recipe 'nodejs'
include_recipe 'sudo'

%w[
  tree
  openssl
  smake
  proj
  wget
  geos
  imagemagick
  sqlite
  libspatialite
  makedepend
  gradle
  groovy
  libpng
  libgeotiff
  libxml2
  libxslt
  libpuzzle
].each do |library|
  package library
end

# Install 'nomad-cli', useful command line tools for Apple dev utilities.
execute 'install nokogiri hack' do
  command "env ARCHFLAGS='-arch x86_64' gem install nokogiri #{node[:gem][:nokogiri][:flags]}"
end
gem_package 'shenzhen'
gem_package 'cupertino'

execute 'sudo easy_install pip' do
  user Etc.getlogin
end

%w[
  Appium-Python-Client
  beautifulsoup4
  csvkit
  docutils
  Jinja2
  LatLon
  mustaine
  numpy
  Pillow
  pypuzzle
  requests
  selenium
  teamcity-messages
].each do |library|
  python_pip library
end

unless data_bag('apple_dev_portal').empty?
  include_recipe 'foreflight_build_agent::dev_portal_resources'
end

# Install Xcode if the attribute with the URL is specified (probably broken, easier to just install Xcode manually sadly enough.)
unless node[:xcode].nil?
  Chef::Log.info 'Xcode node detected, installing Xcode from custom location.'

  unless node[:xcode][:download_url].nil?
    Chef::Log.info "Download from #{node[:xcode][:download_url]}"
    dmg_package 'Xcode' do
      source node[:xcode][:download_url]
      checksum node[:xcode][:checksum] unless node[:xcode][:checksum].nil?
      action :install
    end
  end
end

unless node[:appium].empty?
  include_recipe 'foreflight_build_agent::appium'
end

#Disable software update because it will update Xcode unexpectedly.
execute 'disable software auto-update' do
  command 'softwareupdate --schedule off'
end

include_recipe 'sprout-osx-settings::global_environment_variables'
include_recipe 'sprout-osx-settings::set_start_up_automatically'
include_recipe 'sprout-osx-settings::finder_display_full_path'
include_recipe 'sprout-osx-settings::set_finder_show_all_hd_on_desktop'
include_recipe 'sprout-osx-settings::sshd_on'
include_recipe 'sprout-osx-settings::timemachine'
include_recipe 'sprout-osx-settings::tcp_keepalive'
include_recipe 'sprout-osx-settings::safari_preferences'
include_recipe 'sprout-osx-settings::set_menubar_clock_format'
include_recipe 'sprout-osx-settings::menubar'
include_recipe 'sprout-osx-apps::textmate2'
include_recipe 'java'

# Install ForeFlight's application server.
unless node[:resin].nil?
  include_recipe 'foreflight_build_agent::resin4'
end

# Finally install TeamCity.
include_recipe 'teamcity::agent'