resin_file = "#{Dir.home(Etc.getlogin)}/resin-pro-4.tar.gz"
resin_directory = "/foreflight/resin"
resin_version = node['resin']['version']

directory '/foreflight' do
  recursive true
  action :create
  owner Dir.home(Etc.getlogin)
end

directory '/foreflight/data' do
  recursive true
  action :create
  owner Etc.getlogin
end

remote_file resin_file do
  source "http://caucho.com/download/resin-pro-#{resin_version}.tar.gz"
end

execute 'untar resin' do
  command "tar -xzf #{resin_file} --directory /foreflight"
  creates "#{resin_directory}-pro-#{resin_version}"
end

execute 'link resin' do
  command "ln -sf #{resin_directory}-pro-#{resin_version} #{resin_directory}"
end

unless node['resin']['sqlitejdbc'].nil?
  sqlite_version = node['resin']['sqlitejdbc']['version']
  remote_file "#{resin_directory}/lib/sqlite-jdbc-#{sqlite_version}.jar" do
    source "http://search.maven.org/remotecontent?filepath=org/xerial/sqlite-jdbc/#{sqlite_version}/sqlite-jdbc-#{sqlite_version}.jar"
  end
end

# Record path to attributes.
node.default['resin']['path'] = "#{resin_directory}-pro-#{resin_version}"

# Add to system properties so we can filter by build agent in TeamCity.
system_properties = node.default['teamcity']['agents']['default']['system_properties']
system_properties['resin_path'] = node['resin']['path']
system_properties['resin_version'] = resin_version