#!/bin/bash
REPO_NAME=foreflight_build_agent
set -e

XCODEBUILD_PATH=$(which xcodebuild)

if [ -z ${BUILD_SERVER} ]; then
    echo "Environment variable BUILD_SERVER must be defined, currently ${BUILD_SERVER}"
    exit 1
fi

if [ ! -e ${XCODEBUILD_PATH} ]; then
    echo "Can not find Xcode. Please install Xcode prior to running this script."
    exit 1
fi

if [ -n $(gem list | grep -i berkshelf-solo) ]; then
    echo "Soloist not found, installing..."
    gem install --force --no-ri --no-rdoc soloist berkshelf berkshelf-solo
fi

mkdir -p /opt
mkdir -p /foreflight
mkdir -p ~/cookbooks

pushd `pwd`
cd ~/cookbooks
cat > soloistrc <<EOF
cookbook_paths:
- $PWD
- $PWD/${REPO_NAME}/berks-cookbooks
recipes:
- ${REPO_NAME}::default
EOF

if [[ -d ${REPO_NAME} ]]; then
	git -C ${REPO_NAME} pull
else
	git clone https://github.com/foreflight/${REPO_NAME}.git
fi
if [[ -d dmg ]]; then
	git -C dmg pull
else
	git clone https://github.com/opscode-cookbooks/dmg.git
fi
cd ~/cookbooks/${REPO_NAME}
berks vendor
cd ~/cookbooks
soloist
popd